package com.jpattern.orm.test;

import java.util.Date;

import com.jpattern.orm.BaseTest;
import com.jpattern.orm.IJPOrm;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.test.domain.AutoId;

/**
 * 
 * @author Francesco Cina
 *
 * 20/mag/2011
 */
public class AutoIdTest extends BaseTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testAutoId() throws Exception {
		IJPOrm jpOrm = getJPOrm();
		
		jpOrm.register(AutoId.class);
		
        AutoId autoId = new AutoId();
        autoId.setValue("value for test " + new Date().getTime() );
		
		// CREATE
        ISession conn = jpOrm.session();
        ITransaction tx = conn.getTransaction();
        conn.save(autoId);
        tx.commit();
        
        
        System.out.println("autoId id: " + autoId.getId());
        assertTrue( autoId.getId() >= 100 );
        
        // LOAD
        AutoId autoIdLoad1 = conn.find(AutoId.class, autoId.getId() );
        assertNotNull(autoIdLoad1);
        assertEquals( autoId.getId(), autoIdLoad1.getId() );
        assertEquals( autoId.getValue(), autoIdLoad1.getValue() );
        
        //UPDATE
        tx = conn.getTransaction();
        autoIdLoad1.setValue("new Value " + new Date().getTime() );
        conn.update(autoIdLoad1);
        tx.commit();
        
        // LOAD
        AutoId autoIdLoad2 = conn.find(AutoId.class, autoId.getId() );
        assertNotNull(autoIdLoad2);
        assertEquals( autoIdLoad1.getId(), autoIdLoad2.getId() );
        assertEquals( autoIdLoad1.getValue(), autoIdLoad2.getValue() );
        
        //DELETE
        tx = conn.getTransaction();
        conn.delete(autoIdLoad2);
        tx.commit();
        AutoId autoIdLoad3 = conn.find(AutoId.class, autoId.getId() );
        assertNull(autoIdLoad3);
        
	}

}
