package com.jpattern.orm.test;

import java.util.Date;

import com.jpattern.orm.BaseTest;
import com.jpattern.orm.IJPOrm;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.test.domain.People;

/**
 * 
 * @author Francesco Cina
 *
 * 20/mag/2011
 */
public class PeopleTest extends BaseTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testCrudPeople() throws Exception {
		IJPOrm jpOrm =getJPOrm();
		
		jpOrm.register(People.class);
		
        long id = new Date().getTime();
		People people = new People();
		people.setId( id );
		people.setFirstname( "people" );
		people.setLastname("Wizard");
		
		// CREATE
        ISession conn = jpOrm.session();
        ITransaction tx = conn.getTransaction();
        conn.save(people);
        tx.commit();
        
        System.out.println("People saved with id: " + people.getId());
        assertFalse( id == people.getId() );
        id = people.getId();
        
        // LOAD
        tx = conn.getTransaction();
        People peopleLoad1 = conn.find(People.class, id);
        assertNotNull(peopleLoad1);
        assertEquals( people.getId(), peopleLoad1.getId() );
        assertEquals( people.getFirstname(), peopleLoad1.getFirstname() );
        assertEquals( people.getLastname(), peopleLoad1.getLastname() );
        
        //UPDATE
        peopleLoad1.setFirstname("Wizard name");
        conn.update(peopleLoad1);
        tx.commit();
        
        // LOAD
        tx = conn.getTransaction();
        People peopleLoad2 = conn.find(People.class, new Object[]{id});
        assertNotNull(peopleLoad2);
        assertEquals( peopleLoad1.getId(), peopleLoad2.getId() );
        assertEquals( peopleLoad1.getFirstname(), peopleLoad2.getFirstname() );
        assertEquals( peopleLoad1.getLastname(), peopleLoad2.getLastname() );
        
        //DELETE
        conn.delete(peopleLoad2);
        tx.commit();
        
        tx = conn.getTransaction();
        People peopleLoad3 = conn.find(People.class, new Object[]{id});
        assertNull(peopleLoad3);
        tx.commit();
        
	}

}
