package com.jpattern.orm.test.h2;

import java.util.Date;

import com.jpattern.orm.BaseTest;
import com.jpattern.orm.IJPOrm;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.test.domain.Blobclob_ByteArray;

/**
 * 
 * @author Francesco Cina
 *
 * 20/mag/2011
 */
public class BlobClob_ByteArray_Test extends BaseTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testCrudBlobclob() throws Exception {
		IJPOrm jpOrm =getJPOrm();
		
		jpOrm.register(Blobclob_ByteArray.class);
		
        long id = new Date().getTime();
        
        String text1 = "BINARY STRING TEST 1 " + id;

        String text2 = "BINARY STRING TEST 2 " + id;
		
		Blobclob_ByteArray blobclob = new Blobclob_ByteArray();
		blobclob.setBlob(text1.getBytes());
		blobclob.setClob(text2.getBytes());
		
		// CREATE
        ISession conn = jpOrm.session();
        ITransaction tx = conn.getTransaction();
        conn.save(blobclob);
        tx.commit();
        
        System.out.println("Blobclob saved with id: " + blobclob.getIndex());
        assertFalse( id == blobclob.getIndex() );
        id = blobclob.getIndex();
        
        // LOAD
        tx = conn.getTransaction();
        Blobclob_ByteArray blobclobLoad1 = conn.find(Blobclob_ByteArray.class, new Object[]{id});
        assertNotNull(blobclobLoad1);
        assertEquals( blobclob.getIndex(), blobclobLoad1.getIndex() );
        
        String retrieved1 = new String(blobclobLoad1.getBlob());
        System.out.println("Retrieved1 String " + retrieved1);
        assertEquals( text1 , retrieved1 );
        
        String retrieved2 = new String(blobclobLoad1.getClob());
        System.out.println("Retrieved2 String " + retrieved2);
        assertEquals( text2 , retrieved2 );
        
        //DELETE
        conn.delete(blobclobLoad1);
        Blobclob_ByteArray blobclobLoad2 = conn.find(Blobclob_ByteArray.class, new Object[]{id});
        assertNull(blobclobLoad2);
        tx.commit();
        
	}

}
