package com.jpattern.orm.test.transaction;

import java.util.Date;

import com.jpattern.orm.BaseTest;
import com.jpattern.orm.IJPOrm;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.test.domain.Employee;

/**
 * 
 * @author Francesco Cina
 *
 * 20/mag/2011
 */
public class EmployeeTransactionTest extends BaseTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testTransaction1() throws Exception {
		IJPOrm jpOrm =getJPOrm();
		
		jpOrm.register(Employee.class);
		
        long id = new Date().getTime();
		Employee employee = new Employee();
		employee.setId( id );
		employee.setAge( 44 );
		employee.setEmployeeNumber( ("" + id).substring(0, 9) );
		employee.setName("Wizard");
		employee.setSurname("Cina");
		
		// CREATE
        ISession conn = jpOrm.session();
        ITransaction tx = conn.getTransaction();
        conn.save(employee);
        tx.rollback();
        
        // LOAD
        tx = conn.getTransaction();
        Employee employeeLoad1 = conn.find(Employee.class, new Object[]{id});
        assertNull(employeeLoad1);
        tx.commit();
        
	}

}
